Code.require_file "../../test_helper.exs", __DIR__

defmodule Mix.Tasks.Compile.YeccTest do
  use MixTest.Case
  import ExUnit.CaptureIO

  test "tries to compile src/test_fail.yrl" do
    in_fixture "compile_yecc", fn ->
      File.write!("src/test_fail.yrl", """)
      oops.
      """

      output = capture_io fn ->
        Mix.Tasks.Compile.Yecc.run []
      end

      assert output =~ "src/test_fail.yrl:1: syntax error before:"
    end
  end

  test "compiles src/test_ok.yrl" do
    in_fixture "compile_yecc", fn ->
      Mix.Tasks.Compile.Yecc.run []

      assert_received { :mix_shell, :info, ["Compiled src/test_ok.yrl"] }
      assert File.regular?("src/test_ok.erl")

      Mix.Tasks.Compile.Yecc.run []
      refute_received { :mix_shell, :info, ["Compiled src/test_ok.yrl"] }

      Mix.Tasks.Compile.Yecc.run ["--force"]
      assert_received { :mix_shell, :info, ["Compiled src/test_ok.yrl"] }
    end
  end
end
